
#=============================================================================
# ubiqun_lib.pl: Perl library for ubiqun.pl/ubiqun.exe (ver.20030913)
#
# Copyright (C) 2002-2003 OHKUBO Masahiko <mah@pobox.ne.jp>
# The latest version is available here: http://mah.pobox.ne.jp/ubiqun/
#=============================================================================

use strict;
use vars '%setting';



# ǥեͤΥå (ΤΤߡ%setting ȿǤ)
sub SET_SETTING_DEFAULT {
	my(%output);

	%output = (
		# ƥŪѿΥߡ
		# (Ǥ̵̣ͤץब̤θĽͤꤹ)
			'program_name' => '',
			'program_version' => '',
			'program_author' => '',
			'program_url' => '',
			'file_log' => '',
			'seconds_filelock' => '',
			'date' => '',
			'time' => '',
			'time_rfc_jst' => '',
			'time_rfc_gmt' => '',
			'dir_program' => '',
			'file_program' => '',
			'dir_data' => '',
			'file_input' => '',
			'function_crypt' => '',
			'mail_charset' => '',
			'mail_split_now' => '',
			'mail_counter' => '',
			'mail_ratio_compression' => '',
		# ƥŪѿΥǥե
		# (Ǥͤͭ)
			'seconds_remail' => '8',
			'seconds_net' => '50',
			'cleanup_log' => '1',
			'cleanup_log_flag' => 'yet',
			'cleanup_database' => 'yes',
			'cleanup_database_flag' => '',
			'cleanup_uidl' => 5000,
			'mail_statuscheck' => 'yes',
			'mail' => 'yes',
			'debug' => '',
			'debug_log' => '',
			'quiet' => '',
			'demo' => '',
			'input_byte_max' => 256 * 1024,
			'verbose_level_stdout' => 1,
			'verbose_level_log' => 1,
			'verbose_jcode_stdout' => 'euc', #<perl2exe_comment>
			'verbose_jcode_log' => 'euc', #<perl2exe_comment>
#			'verbose_jcode_stdout' => 'sjis', #<perl2exe_execute>
#			'verbose_jcode_log' => 'sjis', #<perl2exe_execute>
			'check_module_netpop3' => '',
			'check_module_netsmtp' => '',
#			'check_module_mailimapclient' => '',
			'check_module_mimew' => '',
			'version_module_netpop3' => '2.23',
			'version_module_netsmtp' => '2.24',
#			'version_module_mailimapclient' => '2.2.6',
			'file_data_phone_default' => 'ubiqun_phonetype.dat',
			'file_data_symbol' => 'ubiqun_symbol.dat',
			'file_data_filtering' => 'user_filtering.dat',
			'file_data_command' => 'user_command.dat',
			'file_data_phone' => 'user_phone.dat',
			'file_data_server' => 'user_server.dat',
			'file_data_status' => '.status.dat',
			'dir_data_database' => '.database/',
			'file_data_database_lastaccess' => '.lastaccess.dat',
			'dir_data_mbox' => '.mailbox/',
			'file_data_mbox_counter' => '.counter.dat',
			'dir_data_spool' => '.spool/',
			'dir_data_pop' => '.pop/',
			'mail_cut_pattern_frequency' => 2,
			'mail_quotation_regex' => '^ {0,2}?([^>|]{0,16}?)([>|]{1,4}?)( *)(.*)$',
			'mail_compress_quotation_counter' => 'no',
			'mail_charset_default' => 'japanese',
			'mail_charset_japanese' => 'iso\-2022\-jp(\-[0-9])?|shift[_\-]jis|(x\-)?euc\-jp',
			'mail_database_expire' => 365,
			'mail_database_quota' => 10240,
			'mail_database_common_rate_activate' => 0.25, # 1 >= activate > deactivate > forget >= 0
			'mail_database_common_rate_deactivate' => 0.15,
			'mail_database_common_rate_forget' => 0.001,
			'mail_database_common_fuzzy' => 'yes',
			'mail_database_common_length_activate' => 5,
			'mail_database_personal_rate_activate' => 0.4, # 1 >= activate > deactivate > forget >= 0
			'mail_database_personal_rate_deactivate' => 0.2,
			'mail_database_personal_rate_forget' => 0.125,
			'phone_max_order' => 2,
			'server_max_order' => 2,
			'mail_cut_subject_regex' => '',
			'mail_cut_body_regex' => '',
			'mail_remain_body_regex' => '',
			'mail_replace_url_string' => '<URL>',
			'command_forwarding' => '',
			# (: <http://www.din.or.jp/~ohzaki/perl.htm#Mail>)
			'mail_address_regex' =>
				q{(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\} .
				q{\[\]\000-\037\x80-\xff])|"[^\\\\\x80-\xff\n\015"]*(?:\\\\[^\x80-\xff][} .
				q{^\\\\\x80-\xff\n\015"]*)*")(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x} .
				q{80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|"[^\\\\\x80-} .
				q{\xff\n\015"]*(?:\\\\[^\x80-\xff][^\\\\\x80-\xff\n\015"]*)*"))*@(?:[^(} .
				q{\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\0} .
				q{00-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[^\x80-\xff])*} .
				q{\])(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,} .
				q{;:".\\\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[} .
				q{^\x80-\xff])*\]))*},
			# (: <http://www.din.or.jp/~ohzaki/perl.htm#httpURL>)
			'mail_url_http_regex' =>
				q{\b(?:https?|shttp)://(?:(?:[-_.!~*'()a-zA-Z0-9;:&=+$,]|%[0-9A-Fa-f} .
				q{][0-9A-Fa-f])*@)?(?:(?:[a-zA-Z0-9](?:[-a-zA-Z0-9]*[a-zA-Z0-9])?\.)} .
				q{*[a-zA-Z](?:[-a-zA-Z0-9]*[a-zA-Z0-9])?\.?|[0-9]+\.[0-9]+\.[0-9]+\.} .
				q{[0-9]+)(?::[0-9]*)?(?:/(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f]} .
				q{[0-9A-Fa-f])*(?:;(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-} .
				q{Fa-f])*)*(?:/(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f} .
				q{])*(?:;(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)*)} .
				q{*)?(?:\?(?:[-_.!~*'()a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])} .
				q{*)?(?:#(?:[-_.!~*'()a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*} .
				q{)?},
			# (: <http://www.din.or.jp/~ohzaki/perl.htm#ftpURL>)
			'mail_url_ftp_regex' =>
				q{\bftp://(?:(?:[-_.!~*'()a-zA-Z0-9;&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*} .
				q{(?::(?:[-_.!~*'()a-zA-Z0-9;&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)?@)?(?} .
				q{:(?:[a-zA-Z0-9](?:[-a-zA-Z0-9]*[a-zA-Z0-9])?\.)*[a-zA-Z](?:[-a-zA-} .
				q{Z0-9]*[a-zA-Z0-9])?\.?|[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)(?::[0-9]*)?} .
				q{(?:/(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*(?:/(?} .
				q{:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)*(?:;type=[} .
				q{AIDaid])?)?(?:\?(?:[-_.!~*'()a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9} .
				q{A-Fa-f])*)?(?:#(?:[-_.!~*'()a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9A} .
				q{-Fa-f])*)?},
		# ѿΥߡ
		# (Ǥ̵̣ͤեǥǥեͤꤹ)
			'mail_save' => '',
			'mail_cut_pattern' => '',
			'mail_convert_zenhan' => '',
			'mail_compress_quotation' => '',
			'mail_compress_quotation_line' => '',
			'mail_convert_space' => '',
			'mail_convert_sentence' => '',
			'mail_use_database' => '',
			'mail_byte' => '',
			'mail_jcode' => '',
			'mail_jcode_subject' => '',
			'mail_hankakukana' => '',
			'mail_compress_line' => '',
			'mail_cr' => '',
			'mail_split' => '',
			'mail_sendreverse' => '',
			'mail_optimize_zenhan' => '',
			'mail_add_contenttype' => '',
			'mail_replace_url' => '',
			'macro_envelope_from_1' => '',
			'macro_envelope_from_2' => '',
			'macro_envelope_to_1' => '',
			'macro_envelope_to_2' => '',
			'macro_header_from_1' => '',
			'macro_header_from_2' => '',
			'macro_header_to_1' => '',
			'macro_header_to_2' => '',
			'macro_header_cc_1' => '',
			'macro_header_cc_2' => '',
			'macro_header_bcc_1' => '',
			'macro_header_bcc_2' => '',
			'macro_header_reply-to_1' => '',
			'macro_header_reply-to_2' => '',
			'macro_header_errors-to_1' => '',
			'macro_header_errors-to_2' => '',
			'macro_header_subject_1' => '',
			'macro_header_subject_2' => '',
			'macro_header_x-mailer_1' => '',
			'macro_header_x-mailer_2' => '',
			'macro_header_x-remailer_1' => '',
			'macro_header_x-remailer_2' => '',
			'macro_body_header_1' => '', 
			'macro_body_header_2' => '',
			'macro_body_footer_1' => '', 
			'macro_body_footer_2' => '',
			'macro_byte_header' => '',
			'mail_timecheck_sun' => '',
			'mail_timecheck_mon' => '',
			'mail_timecheck_tue' => '',
			'mail_timecheck_wed' => '',
			'mail_timecheck_thu' => '',
			'mail_timecheck_fri' => '',
			'mail_timecheck_sat' => '',
		# 桼ѿΥߡ
		# (Ǥ̵̣ͤեǤ˥ߡ桼եͤꤹ)
			'phone_name' => '',
			'phone_type' => '',
			'phone_address' => '',
			'server_smtp' => '',
			'server_smtp_port' => '',
		# 桼ѿΥߡ
		# (Ǥ̵̣ͤ桼եͤꤹ)
			'program_address' => '',
		# 桼ѿΥߡ
		# (Ǥ̵̣ͤޥɥ饤ͤꤹ)
			'mode' => '',
	);
	return(\%output);
}



# ޥɥ饤󥪥ץɤ߼
sub READ_CMDLINE {
	my($ref_argv) = @_;
	my($counter, %output, $tmp1, $tmp2, $tmp3);

	for ($counter = 0; $counter < scalar(@$ref_argv); $counter ++) {
		$tmp1 = $$ref_argv[$counter];
		if ($tmp1 =~ /^-(.*)$/) {
			($tmp2, $tmp3) = split('=', $1, 2);
			if (($tmp2 =~ /^dir_/) || ($tmp2 =~ /^file_/)) {
				$tmp3 = &UNESCAPE_SPACE($tmp3);
			}
			if ($tmp3 eq '') {
				$tmp3 = 'yes';
			}
			$output{$tmp2} = $tmp3;
		}
	}
	return(\%output);
}



# ˤ뤫å (%check  %master ˤ뤫ɤ)
sub CHECK_DEFINITION {
	my($mode, $ref_master, $ref_check) = @_;
	my($key, $counter);

	while (($key, undef) = each(%$ref_check)) {
		if (!(defined($$ref_master{$key}))) {
			if (ref($mode)) {
				$mode = $$mode{$key};
			}
			&VERBOSE('normal', 'normal', 'WARNING: type miss? / key = ' . $key . ' (by '. $mode .')');
			$counter ++;
		}
	}
	if ($counter > 0) {
		&VERBOSE('error', 'error', 'ERROR: ' . $counter . ' syntax error(s) are found in some definition above.');
	}
	return;
}



# ٥˽äơåɽȥϿԤ (error=顼normal=̡detail=ܺ١nothing=⤷ʤ)
sub VERBOSE {
	my($level_stdout, $level_log, $message) = @_;
	my(%level) = ('error' => 0, 'normal' => 1, 'detail' => 2, 'nothing' => 9);

	$level_stdout = $level{$level_stdout};
	$level_log = $level{$level_log};
	# åɽ
	if ($level_stdout <= $setting{'verbose_level_stdout'}) {
		if ($setting{'verbose_jcode_stdout'} ne 'euc') {
			jcode::convert(\$message, $setting{'verbose_jcode_stdout'}, 'euc');
		}
		if ($level_stdout > 0) {
			print $message . "\n";
		} else {
			warn $message . "\n";
		}
	}
	# Ͽ
	if ($level_log <= $setting{'verbose_level_log'}) {
		if ((defined($setting{'cleanup_log'})) && (defined($setting{'cleanup_log_flag'}))) {
			if (($setting{'cleanup_log'} >= 0) && ($setting{'cleanup_log_flag'} eq 'yet')) {
				$setting{'cleanup_log_flag'} = &CLEANUP_LOG($setting{'file_log'}, $setting{'cleanup_log'});
			}
		}
		$message =~ s/\x0D\x0A/<0D><0A>/g;	# \n in SMTP, Windows
		$message =~ s/\x0A/<0A>/g;	# \n in UNIX
		$message =~ s/\x0D/<0D>/g;	# \n in Macintosh
		&SAVE_LOG($setting{'file_log'}, $message);
	}
	if (($level_stdout * $level_log) == 0) {
		exit;   #<perl2exe_comment>
#		exit 1; #<perl2exe_execute>
	}
	return;
}



# Ͽ
sub SAVE_LOG {
	my($file, $line) = @_;
	my($file_rename);

	$file_rename = &LOCK_FILE($file);
	open(FILE_LOG, ">>$file_rename");
	chmod(oct('600'), $file_rename);
	if ($setting{'verbose_jcode_log'} ne 'euc') {
		jcode::convert(\$line, $setting{'verbose_jcode_log'}, 'euc');
	}
	($setting{'date'}, $setting{'time'}) = (&GET_DATE())[0,1];
	print FILE_LOG '[' . $setting{'date'} . ',' . $setting{'time'} . ',' . sprintf('%05d', $$) . '] ' . $line . "\n";
	close(FILE_LOG);
	&UNLOCK_FILE($file_rename);
	return;
}



# ݽ
sub CLEANUP_LOG {
	my($file, $day_alive) = @_;
	my($file_rename, $file_tmp, $line, $date_log, $date_now, $date_border, $flag);
	my($day, $mon, $year);

	$file_rename = &LOCK_FILE($file);
	(undef, undef, undef, $day, $mon, $year, undef, undef, undef) = localtime((stat($file_rename))[9]);
	$date_log = sprintf('%04d%02d%02d', $year + 1900, $mon + 1, $day);
	$date_now = (&GET_DATE())[0];
	$date_now = substr($date_now, 0, 4) . substr($date_now, 5, 2) . substr($date_now, 8, 2);
	if ($date_log ne $date_now) {
		# κǽä
		(undef, undef, undef, $day, $mon, $year, undef, undef, undef) = localtime(time - $day_alive * 86400);
		$date_border = sprintf('%04d%02d%02d', $year + 1900, $mon + 1, $day);
		$file_tmp = $file . '.writing';
		open(FILE_LOG1, "$file_rename");
		open(FILE_LOG2, ">$file_tmp");
		chmod(oct('600'), $file_tmp);
		while (defined($line = <FILE_LOG1>)) {
			$date_log = substr($line, 1, 4) . substr($line, 6, 2) . substr($line, 9, 2);
			if ($date_log >= $date_border) {
				print FILE_LOG2 $line;
			}
		}
		close(FILE_LOG2);
		close(FILE_LOG1);
		rename($file_tmp, $file);	# ξ̤ˡǥåե
		unlink($file_rename);
		&VERBOSE('normal', 'normal', 'CLEANUP(log): day_alive = ' . $day_alive . '; file = ' . $file . ';');
		$flag = 'done';
	} else {
		&UNLOCK_FILE($file_rename);
		$flag = 'pass';
	}
	return($flag);
}



# ǡ١եݽ
sub CLEANUP_DATABASE {
	my($dir, $day_expire, $kilobyte_quota) = @_;
	my(@dir_sub1, $dir_sub1, @dir_sub2, $dir_sub2, @file_sub);
	my(@file, $file, %file_size, %file_time);
	my($size_summary, $size_before);

	# ե̤ȹηвĴ٤ʤ顤ꥹȤ
	opendir(DIR, $dir);
	@dir_sub1 = grep(/[^\.]/, readdir(DIR));
	closedir(DIR);
	while (@dir_sub1) {
		$dir_sub1 = $dir . shift(@dir_sub1);
		if (-d $dir_sub1) {
			# japanese etc.
			opendir(DIR, $dir_sub1);
			@dir_sub2 = grep(/[^\.]/, readdir(DIR));
			closedir(DIR);
			@file_sub = ();
			while (@dir_sub2) {
				$dir_sub2 = $dir_sub1 . '/' . shift(@dir_sub2);
				if (-d $dir_sub2) {
					# 00, 01 etc.
					opendir(DIR, $dir_sub2);
					@file_sub = grep(/[^\.]/, readdir(DIR));
					closedir(DIR);
					while (@file_sub) {
						$file = $dir_sub2 . '/' . shift(@file_sub);
						if ($file =~ /\.dat$/i) {
							push(@file, $file);
							$file_size{$file} = (-s $file);
							$file_time{$file} = (-M $file);
						}
					}
				} else {
					# _common.dat
					$file = $dir_sub2;
					if ($file =~ /\.dat$/i) {
						push(@file, $file);
						$file_size{$file} = (-s $file);
						$file_time{$file} = (-M $file);
					}
				}
			}
		}
	}
	# եŤ˥ȤơͤŤΤ (ñ)
	@file = sort { ($file_time{$b} <=> $file_time{$a}) } keys %file_time;
	while(@file) {
		$file = shift(@file);
		if ($file_time{$file} > $day_expire) {
			unlink(&LOCK_FILE($file));
			&VERBOSE('normal', 'normal', 'CLEANUP(database): file = ' . $file . '; lapse = ' . $file_time{$file} . ' days');
			delete($file_size{$file});
		} else {
			$size_summary += $file_size{$file};
		}
	}
	$size_before = $size_summary;
	# եŤ˥ȤơŤΤ (̤ͤ꾮ʤޤ)
	@file = sort { ($file_time{$b} <=> $file_time{$a}) } keys %file_size;
	while( (@file) && ($size_summary >= ($kilobyte_quota * 1024)) ) {
		$file = shift(@file);
		unlink(&LOCK_FILE($file));
		&VERBOSE('normal', 'normal', 'CLEANUP(database): file = ' . $file . '; size = ' . $file_size{$file} . ' bytes');
		$size_summary -= $file_size{$file};
	}
	if ($size_summary != $size_before) {
		&VERBOSE('normal', 'normal', 'CLEANUP(database): size = ' . $size_before . ' -> ' . $size_summary . ' bytes');
	} else {
		&VERBOSE('normal', 'normal', 'CLEANUP(database): size = ' . $size_before . ' bytes');
	}
	return;
}



# եå
sub LOCK_FILE {
	my($file) = @_;
	my($counter, $dir, $file_rename, $file_lock, $time);
	my($file_base, $file_dummy, @tmp, @file);

	if (index($file, '/') > -1) {
		$file =~ /(.*)\/(.*)$/;
		$dir = $1 . '/';
		$file_base = '^' . quotemeta($2);
	} else {
		$dir = './';
		$file_base = '^' . quotemeta($file);
	}
	$file_lock = $file_base . '\.lock_(\d+)';

	if (scalar(&LOCK_FILE_GREP($dir, $file_base)) == 0) {
		# äݤեϲ˺ (ִŪʷ꤬)
		open(FILE_LOCK, ">$file");
		chmod(oct('600'), $file);
		close(FILE_LOCK);
	}
	# ¸եФơեåߤ
	for ($counter = 0; $counter < $setting{'seconds_filelock'}; $counter ++) {
		$file_rename = $file . '.lock_' . time;
		if (rename($file, $file_rename)) {
			return($file_rename);
		}
		&VERBOSE('normal', 'nothing', 'SLEEP(' . ($counter + 1). '/' . $setting{'seconds_filelock'}. '): waiting lock file = ' . $file);
		sleep(1);
	}
	# եåǤʤäΤ
	@file = &LOCK_FILE_GREP($dir, $file_lock);
	while (@file) {
		$file_lock = $dir . shift(@file);
		$file_lock =~ /\.lock_(\d+)$/;
		$time = $1;
		$file_rename = $file . '.lock_' . time;
		if (((time - $time) > $setting{'seconds_filelock'} * 2) && (rename($file_lock, $file_rename))) {
			return($file_rename);
		}
	}
	&VERBOSE('error', 'nothing', 'ERROR: cannot lock file = ' . $file);
	return(undef);
}
sub LOCK_FILE_GREP {
	my($dir, $file_lock) = @_;
	my(@file);

	opendir(DIR_LOCK, $dir);
	@file = grep(/$file_lock/, readdir(DIR_LOCK));
	closedir(DIR_LOCK);
	return(@file);
}



# եΥå򳰤
sub UNLOCK_FILE {
	my($file_rename) = @_;
	my($file, $time);

	$file = $file_rename;
	$file_rename =~ /\.lock_(\d+)$/;
	$time = $1;
	$file =~ s/\.lock_$time$//;
	rename($file_rename, $file);
	return;
}



# ߤա
sub GET_DATE {
	$ENV{'TZ'} = 'JST-9';
	my($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst);
	my($date, $time, $rfc_jst, $rfc_gmt);
	my(@weekday) = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
	my(@month) = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

	# GMT
	($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = gmtime;
	$time = sprintf('%02d:%02d:%02d', $hour, $min, $sec);
	$day = sprintf('%02d', $day);
	$rfc_gmt = $weekday[$wday] . ', ' . $day . ' ' . $month[$mon] . ' ' . ($year + 1900) . ' ' . $time . ' GMT';
	# JST
	($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = localtime;
	$date = sprintf('%04d/%02d/%02d', $year + 1900, $mon + 1, $day);
	$time = sprintf('%02d:%02d:%02d', $hour, $min, $sec);
	$day = sprintf('%02d', $day);
	$rfc_jst = $weekday[$wday] . ', ' . $day . ' ' . $month[$mon] . ' ' . ($year + 1900) . ' ' . $time . ' +0900';
	return($date, $time, $rfc_jst, $rfc_gmt);
}



# ᡼إåȴФ
sub EXTRACT_HEADER {
	my($ref_text, $address_regex) = @_;
	my($counter, @text, $line, %header, $text, @body, $key, $value);
	my(@header, @address);

	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		#  or "--------" (for ſȬ᡼ե) ǲϽλ
		if (($$ref_text[$counter] eq '') || ($$ref_text[$counter] eq '--------')) {
			last;
		}
	}
	$text = join("\n", splice(@$ref_text, 0, $counter));
	$text =~ s/\n\s+/ /g;
	@text = split("\n", $text);
	@body = splice(@$ref_text, 1);
	while (@text) {
		($key, $value) = split(':', shift(@text), 2);
		$key =~ tr/a-z/A-Z/;
		$value =~ s/^\s+//;
		$value =~ s/\s+$//;
		if (exists($header{$key})) {
			$header{$key} = $value . "\t" . $header{$key};
		} else {
			$header{$key} = $value;
		}
	}
	# Subject  MIME ǥ
	if (exists($header{'SUBJECT'})) {
		$header{'X-ORIGINAL-SUBJECT'} = $header{'SUBJECT'};
		$header{'SUBJECT'} = &DECODE_MIME_LINE($header{'SUBJECT'});
	}
	# ᡼륢ɥ쥹
	@header = ('FROM', 'TO', 'CC');
	while (@header) {
		$key = shift(@header);
		if (exists($header{$key})) {
			$header{'X-ORIGINAL-' . $key} = $header{$key};
			$line = $header{$key};
			@address = ();
			while ($line =~ /($address_regex)/o) {
				$value = $1;
				if ((!($line =~ /"\s*$value\s*"/)) && (!($line =~ /\(\s*$value\s*\)/))) {
					# ᡼륢ɥ쥹餷Τ ""  () ˰ϤޤƤʤä
					push(@address, $value);
				}
				$value = quotemeta($value);
				$line =~ s/$value//;
			}
			$header{$key} = join(',', @address);
		}
	}
	# ̰: $setting{'mail_charset'} ط
	$setting{'mail_charset'} = &EXTRACT_CHARSET($header{'CONTENT-TYPE'});
	return(\%header, \@body);
}



# ƥȥեɤ߹
sub LOAD_FILE {
	my($file) = @_;
	my($line, $text, $code, @text, $ref_text);

	$/ = undef;
	open(FILE, $file) || &VERBOSE('error', 'error', 'ERROR: cannot open - file = ' . $file);
	$text = <FILE>;
	close(FILE);
	$/ = "\n";
	($ref_text, $code) = &CONVERT_EUC(\$text);
	@text = split("\n", $$ref_text);
	return(\@text, $code);
}



# եɤ߹
sub LOAD_CONFIGFILE_CONDITION {
	my($file, $ref_header, $ref_body, $ref_symbol, $flag_case) = @_;
	my($line, $key, $value);
	my($flag_mode, $flag_match_or, $flag_match_and, $flag_continue) = ('header', 'no', 'no', 'no');
	my(@header_or, @header_and, %output, $ref_text);
	my($body, @tmp, $ref_tmp, $tmp);
	my($flag_cache, $counter, @output);

	# ᡼ʸڤƹ
	if (ref($ref_body) eq 'ARRAY') {
		$body = join(' ', @$ref_body);
		jcode::tr(\$body, '', ' ');
		push(@tmp, $body);
		$ref_tmp = &CONVERT_SPACE(\@tmp, $ref_symbol, 'powerful');
		$body = $$ref_tmp[0];
	}
	($flag_cache, $ref_text) = &LOAD_FILE_CACHE($file, 'arrangement');
	if ($flag_cache ne 'yes') {
		# եɤ
		&VERBOSE('detail', 'detail', 'LOAD(filtering): file = ' . $file);
		$ref_text = (&LOAD_FILE($file))[0];
		for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
			$line = $$ref_text[$counter];
			if ((!($line =~ /^\s*#/)) && (!($line =~ /^\s*$/))) {
				# # ǻϤޤäƤԡԤɤФ
				push(@output, $line);
			}
		}
		&SAVE_FILE_CACHE($file, 'arrangement', \@output);
		$ref_text = \@output;
	}
	while (@$ref_text) {
		$line = shift(@$ref_text);
		if ($line =~ /^\w(\S+):/) {
			# 
			if ($flag_mode eq 'parameter') {
				# Ԥ (ιԤϥѥ᡼Ԥä)
				@header_or = ();
				if ($flag_continue eq 'no') {;
					last;
				}
			}
			$flag_mode = 'condition';
			push(@header_or, $line);
		} else {
			# ѥ᡼
			if ($flag_mode eq 'condition') {
				# ѥ᡼Ԥ (ιԤϾԤä)
				$flag_match_or = 'no';
				while (@header_or) {
					# Υޥå (or)
					$flag_match_and = 'yes';
					$tmp = '';
					@header_and = split(/\s+\&\&\s+/, shift(@header_or));
					while(@header_and) {
						# Υޥå (and)
						($key, $value) = split(/\s*:\s*/, shift(@header_and), 2);
						$key =~ tr/a-z/A-Z/;
						if ($key eq 'X-UBIQUN-MAILBODY') {
							# ᡼ʸΥޥå
							if (($flag_case eq 'sensitive') && ($body =~ /$value/)) {
								$tmp .= $key . ' =~ /' . $value . '/; ';
							} elsif (($flag_case eq 'insensitive') && ($body =~ /$value/i)) {
								$tmp .= $key . ' =~ /' . $value . '/i; ';
							} else {
								$flag_match_and = 'no';
								last;
							}
						} else {
							# ᡼إåΥޥå
							if ($$ref_header{$key} =~ /$value/i) {
								$tmp .= $key . ' = ' . $$ref_header{$key} . ' (=~ /' . $value . '/i); ';
							} else {
								$flag_match_and = 'no';
								last;
							}
						}
					}
					if ($flag_match_and eq 'yes') {
						$flag_match_or = 'yes';
						chop($tmp);
						&VERBOSE('normal', 'normal', 'MATCH: ' . $tmp);
						last;
					}
				}
			}
			if ($flag_match_or eq 'yes') {
				# ޥå郎äʤХѥ᡼
				($key, $value) = split(/\s*=\s*/, $line, 2);
				$key =~ s/^\s*//;
				$key =~ tr/A-Z/a-z/;
				if ($key eq 'continue') {
					# ȹ³ʤ (ʬ)
					$flag_continue = 'yes';
				} elsif ($key eq 'exit') {
					# ȹ³ʤʤ (ʬ)
					$flag_continue = 'no';
				} else {
					# (̾ι)
					$output{$key} = $value;
					$flag_continue = 'no';
				}
			} else {
				# ˥ޥåʤä
				$flag_continue = 'yes';
			}
			$flag_mode = 'parameter';
		}
	}
	return(\%output);
}



# եɤ߹
sub LOAD_CONFIGFILE {
	my($file, $mode) = @_;
	my($line, $section, $key, $value, %output, $ref_text);
	my($flag_cache, $ref_output);

	if ($mode ne 'direct') {
		($flag_cache, $ref_output) = &LOAD_FILE_CACHE($file, 'hash');
	}
	if ($flag_cache ne 'yes') {
		# եɤ߹ߤʤ
		&VERBOSE('detail', 'detail', 'LOAD(config): file = ' . $file);
		$ref_text = (&LOAD_FILE($file))[0];
		while (@$ref_text) {
			$line = shift(@$ref_text);
			if ((!($line =~ /^\s*#/)) && (!($line =~ /^\s*$/))) {
				# # ǻϤޤäƤԡԤɤФ
				$line =~ s/^\s+//;
				$line =~ s/\s+$//;
				if ($line =~ /^\[(.*)\]$/) {
					# [HOGEHOGE] ιԤ
					$section = $1;
					$section =~ tr/A-Z/a-z/;
				} else {
					($key, $value) = split(/\s*=\s*/, $line, 2);
					$key =~ tr/A-Z/a-z/;
					$output{$key . ':' . $section} = $value;
				}
			}
		}
		if ($mode ne 'direct') {
			&SAVE_FILE_CACHE($file, 'hash', \%output);
		}
		$ref_output = \%output;
	}
	return($ref_output);
}



# եΥåɤ߹
sub LOAD_FILE_CACHE {
	my($file, $mode) = @_;
	my($file_cache) = &CONVERT_FILENAME_CACHE($file);
	my($key, %output, @output, $ref_output);
	my($line, $counter);

	if ((-r $file) && (-w $file_cache) && ((-M $file) > (-M $file_cache))) {
		open(FILE_CACHE, $file_cache) || return('no');
		&VERBOSE('detail', 'detail', 'LOAD: file = ' . $file_cache . ' (cached)');
		if ($mode eq 'hash') {
			$counter = 0;
			while (defined($line = <FILE_CACHE>)) {
				chop($line);
				if (($counter % 2) == 0) {
					$key = $line;
				} else {
					$output{$key} = $line;
				}
				$counter ++;
			}
			$ref_output = \%output;
		} elsif ($mode eq 'arrangement') {
			while (defined($line = <FILE_CACHE>)) {
				chop($line);
				push(@output, $line);
			}
			$ref_output = \@output;
		}
		close(FILE_CACHE);
		return('yes', $ref_output);
	} else {
		return('no');
	}
}



# եΥå¸
sub SAVE_FILE_CACHE {
	my($file, $mode, $ref_output) = @_;
	my($file_cache) = &CONVERT_FILENAME_CACHE($file);
	my($key, $value, $file_rename, $counter);

	$file_rename = &LOCK_FILE($file_cache);
	open(FILE_CACHE, ">$file_rename");
	chmod((stat($file))[2], $file_rename);
	if ($mode eq 'hash') {
		while (($key, $value) = each(%$ref_output)) {
			print FILE_CACHE $key . "\n";
			print FILE_CACHE $value . "\n";
		}
	} elsif ($mode eq 'arrangement') {
		for ($counter = 0; $counter < scalar(@$ref_output); $counter ++) {
			print FILE_CACHE $$ref_output[$counter] . "\n";
		}
	}
	close(FILE_CACHE);
	&UNLOCK_FILE($file_rename);
	return;
}



# åեκ߽衦̾
sub CONVERT_FILENAME_CACHE {
	my($file) = @_;

	$file =~ /([^\/]+)$/;
	return($setting{'dir_data'} . '.cache_' . $1);
}



# ե񤭽Ф
sub SAVE_CONFIGFILE_SERVER {
	my($file, $ref_exist_password) = @_;
	my($line, $key, $value, $file_rename, $code, $ref_text, $text_new, $flag_section);

	# եɤ߹ߤʤ
	$file_rename = &LOCK_FILE($file);
	($ref_text, $code) = &LOAD_FILE($file_rename);
	$flag_section = 'no';
	while (@$ref_text) {
		$line = shift(@$ref_text);
		if ((!($line =~ /^\s*#/)) && (!($line =~ /^\s*$/))) {
			# # ǻϤޤäƤԡԤɤФ
			$line =~ s/^\s+//;
			$line =~ s/\s+$//;
			if ($line =~ /^\[(.*)_(\d+)\]$/) {
				# [HOGEHOGE_N] ιԤ
				if ($$ref_exist_password{$2} eq 'yes') {
					# password ĤäƤ륻
					$flag_section = 'yes';
				} else {
					$flag_section = 'no';
				}
			} else {
				($key, $value) = split(/\s*=\s*/, $line, 2);
				$key =~ tr/A-Z/a-z/;
				if (($flag_section eq 'yes') && ($key eq 'password')) {
					$key = 'password_crypted';
					$value = &CRYPT_PASSWORD($value);
					$flag_section = 'done';
				} elsif ((($flag_section eq 'yes') || ($flag_section eq 'done')) && ($key eq 'password_crypted')) {
					next;
				}
				$line = $key . ' = ' . $value;
			}
		}
		$text_new .= $line . "\n";
	}
	# ե񤭽Ф
	open(FILE, ">$file_rename");
	chmod(oct('600'), $file_rename);
	jcode::convert(\$text_new, $code, 'euc');
	print FILE $text_new;
	close(FILE);
	&UNLOCK_FILE($file_rename);
	return;
}



# ѥɤ򾯤ФŹ沽ƤĤ
sub CRYPT_PASSWORD {
	my($line) = @_;

	$line = &MIME::base64encode(unpack('h*', ~ unpack('H*', ~ $line)));	# mimew.pl
	return($line);
}



# ѥɤ沽
sub DECRYPT_PASSWORD {
	my($line) = @_;

	$line = ~ pack('H*', ~ pack('h*', &MIME::base64decode($line)));
	return($line);
}



# ߤΥ᡼륫ȤɤߤȤ
sub LOAD_FILE_MAILCOUNTER {
	my($dir, $file) = @_;
	my($line, $counter);
	my($file_rename);

	$counter = 0;
	&CHECK_DIR($dir, oct('700'));
	$file = $dir . $file;
	$file_rename = &LOCK_FILE($file);
	&VERBOSE('detail', 'detail', 'LOAD(counter): file = ' . $file);
	open(FILE, $file_rename) || &VERBOSE('error', 'error', 'ERROR: cannot open - file = ' . $file);
	while (defined($line = <FILE>)) {
		$counter = $line;
		$counter =~ s/\D//g;
	}
	close(FILE);
	open(FILE, ">$file_rename") || &VERBOSE('error', 'error', 'ERROR: cannot open - file = ' . $file);
	chmod(oct('600'), $file_rename);
	print FILE sprintf('%02d', ($counter + 1) % 100) . "\n";
	close(FILE);
	&UNLOCK_FILE($file_rename);
	return(sprintf('%02d', $counter));
}



# ᡼¸
sub SAVE_MAIL {
	my($counter, $ref_header, $ref_text, $dir) = @_;
	my($file_header) = $dir . $counter . '_header.txt';
	my($file_body) = $dir . $counter . '_body.txt';
	my($key, $value);

	# ᡼إå
	open(FILE, ">$file_header") || &VERBOSE('error', 'error', 'ERROR: cannot open - file = ' . $file_header);
	chmod(oct('600'), $file_header);
	while (($key, $value) = each(%$ref_header)) {
		print FILE $key . ': ' . $value . "\n";
	}
	close(FILE);
	&VERBOSE('detail', 'detail', 'SAVE(mailbox): file = ' . $file_header);
	# ᡼ܥǥ
	open(FILE, ">$file_body") || &VERBOSE('error', 'error', 'ERROR: cannot open - file = ' . $file_body);
	chmod(oct('600'), $file_body);
	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		print FILE $$ref_text[$counter] . "\n";
	}
	close(FILE);
	&VERBOSE('detail', 'detail', 'SAVE(mailbox): file = ' . $file_body);
	return;
}



# ž֤¸
sub SAVE_FILE_STATUS {
	my($file, $status) = @_;
	my($file_rename) = &LOCK_FILE($file);

	open(FILE, ">$file_rename");
	chmod(oct('600'), $file_rename);
	print FILE $status;
	close(FILE);
	&UNLOCK_FILE($file_rename);
	&VERBOSE('detail', 'detail', 'SAVE(status): file = ' . $file);
	return;
}



# ž֤ɤߤȤ
sub LOAD_FILE_STATUS {
	my($file) = @_;
	my($status) = '';
	my($file_rename);

	if (-r ($file)) {
		$file_rename = &LOCK_FILE($file);
		$/ = undef;
		open(FILE, "$file_rename");
		$status = <FILE>;
		close(FILE);
		$/ = "\n";
		&UNLOCK_FILE($file_rename);
		&VERBOSE('detail', 'detail', 'LOAD(status): file = ' . $file);
		$status =~ s/\s//g;
	}
	return($status);
}



# ᡼򥹥ס¸
sub SAVE_MAIL_SPOOL {
	my($ref_header, $ref_text, $dir) = @_;
	my($date, $time, $file);
	my($key, $value, $counter);

	($date, $time) = (&GET_DATE())[0,1];
	$date =~ s/\///g;
	$time =~ s/://g;
	$file = $dir . $date . $time .'_' . sprintf('%05d', $$) . '.txt';

	&CHECK_DIR($dir, oct('700'));
	open(FILE, ">$file") || &VERBOSE('error', 'error', 'ERROR: cannot open - file = ' . $file);
	chmod(oct('600'), $file);
	while (($key, $value) = each(%$ref_header)) {
		print FILE $key . ': ' . $value . "\n";
	}
	print FILE "\n";
	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		print FILE $$ref_text[$counter] . "\n";
	}
	close(FILE);
	&VERBOSE('detail', 'detail', 'SAVE(spool): file = ' . $file);
	return;
}



# ޥɥ饤ѥ᡼κƹ
sub REMAKE_ARGV {
	my($ref_argv) = @_;
	my($counter, $key, $value, $argv);
	my(%key_forbidden) = ('-mode' => 1, '-file_input' => 1);

	for ($counter = 0; $counter < scalar(@$ref_argv); $counter ++) {
		($key, $value) = split('=', $$ref_argv[$counter], 2);
		if ($key_forbidden{$key} != 1) {
			if ($value ne '') {
				if (($key =~ /^-dir_/) || ($key =~ /^-file_/)) {
					$value = &ESCAPE_SPACE($value);
				}
				$argv .= $key . '=' . $value . ' ';
			} else {
				$argv .= $key . ' ';
			}
		}
	}
	return($argv);
}



# ᡼򥹥ס뤫ɤ߽ФƼʬƵƤӽФ
sub LOAD_MAIL_SPOOL {
	my($dir, $ref_argv) = @_;
	my($argv, @file, $file_rename, $command);

	$argv = &REMAKE_ARGV($ref_argv);
	# סե򸫤Ĥ
	opendir(DIR, $dir);
	@file = sort(grep(/^\d{14}_\d{5}\.txt$/, readdir(DIR)));
	closedir(DIR);
	# ƵƤӽФ
	while (@file) {
		$file_rename = &LOCK_FILE($dir . shift(@file));
		if ($file_rename) {
			&EXECUTE_CHILDPROCESS($argv . ' -mail_statuscheck=no -file_input=' . &ESCAPE_SPACE($file_rename), 'spool');
			unlink($file_rename);	# ξ̤ˡǥåե
		}
	}
	return;
}



# ǥ쥯ȥ¸ߤå (̵кäƤߤ)
sub CHECK_DIR {
	my($dir, $mode) = @_;

	if (!(-w $dir)) {
		$dir =~ s/\/$//;	#  Mac OS X + Perl 5.6.0 ǤϤʤưʤ
		mkdir($dir, $mode) || &VERBOSE('error', 'error', 'ERROR: cannot mkdir - dir = ' . $dir . ' (' . $mode . ')');
	}
	return;
}



# ʸ (֡ס֡ס֡ס֡פѴ &CONVERT_SENTENCE ƯʤʤΤ 2 ǹԤ)
sub CONVERT_ZENHAN_1 {
	my($ref_text) = @_;
	my(@text, $text);

	$text = join("\n", @$ref_text);
	jcode::tr(\$text, 'ǡʡˡܡΡϡСáѡ---ڡ', '#$%&\'()*+/:;<=>@[\\]^_`{|}~ 0-9a-zA-Z-');
	$text =~ s//š/g;
	$text =~ s///g;
	$text =~ s///g;
	@text = split("\n", $text);
	return(\@text);
}
sub CONVERT_ZENHAN_2 {
	my($ref_text) = @_;
	my(@text, $text);

	$text = join("\n", @$ref_text);
	jcode::tr(\$text, '', '!?,.');
	@text = split("\n", $text);
	return(\@text);
}



# ʸХʸ (: (&CONVERT_ZENHAN_1,2 εѴ) + ("   Ѵ) Ȥʤ褦ˤ뤳)
sub CONVERT_HANZEN {
	my($text) = @_;

	jcode::tr(\$text, '"#$%&\'()*+/:;<=>@[\\]^_`{|}~ !?,.0-9a-zA-Z-', 'ɡǡʡˡܡΡϡСáѡ---ڡ');
	return($text);
}



# ڡκ
sub CONVERT_SPACE {
	my($ref_text, $ref_symbol, $mode) = @_;
	my(@text, $text, $text_new, $pointer, $pointer_step, $ascii, $ascii_last, $flag_space);
	my($cr) = "\x0A";	# ٤Ƥ OS ǲԤХȤɽ뤿

	$text = join($cr, @$ref_text);
	$text =~ tr/\t/ /;
	$flag_space = 'yes';
	$ascii_last = '(dummy)';
	while ($pointer < length($text)) {
		$ascii = substr($text, $pointer, 1);
		if ($ascii eq ' ') {
			$pointer_step = 1;
			$flag_space = 'yes';
		} elsif ($ascii eq $cr) {
			$pointer_step = 1;
			$ascii_last = '(dummy)';
			$text_new .= $cr;
		} else {
			if (unpack('C', $ascii) >= 0xA1) {
				$pointer_step = 2;
				$ascii .= substr($text, $pointer + 1, 1);
			} else {
				$pointer_step = 1;
			}
			if (($flag_space eq 'yes') && (length($ascii_last) == length($ascii))) {
				# ХʸХʸζǤϤʤڡǡ
				if (length($ascii) == 2) {
					# Хʸ˶ޤƤʤ
					if ($mode eq 'powerful') {
						# ⡼ɤ powerful ʤ  ä
						$text_new .= $ascii;
					} elsif (($$ref_symbol{$ascii_last} == 1) || ($$ref_symbol{$ascii} == 1)) {
						# ⡼ɤ powerful ǤϤʤȤɤ餫ʸʤ  ä
						$text_new .= $ascii;
					} else {
						# ʳ  Ĥ
						$text_new .= ' ' . $ascii;
					}
				} elsif ((length($ascii) == 1) && (($$ref_symbol{$ascii_last} == 1) && ($$ref_symbol{$ascii} == 1))) {
					# Хʸ˶ޤƤơξȤ⵭ʸʤ  ä
					$text_new .= $ascii;
				} else {
					# ʳ  Ĥ
					$text_new .= ' ' . $ascii;
				}
			} else {
				# ХʸХʸζˤ륹ڡ  ä
				$text_new .= $ascii;
			}
			$flag_space = 'no';
			$ascii_last = $ascii;
		}
		$pointer += $pointer_step;
	}
	@text = split($cr, $text_new);
	return(\@text);
}



# ʸեɤ߹
sub LOAD_FILE_SYMBOL {
	my($file) = @_;
	my($line, %symbol);
	my($ref_text);
	my($flag_cache, $ref_output);

	($flag_cache, $ref_output) = &LOAD_FILE_CACHE($file, 'hash');
	if ($flag_cache ne 'yes') {
		&VERBOSE('detail', 'detail', 'LOAD(symbol): file = ' . $file);
		$ref_text = (&LOAD_FILE($file))[0];
		while (@$ref_text) {
			$line = shift(@$ref_text);
			$symbol{$line} = 1;
		}
		&SAVE_FILE_CACHE($file, 'hash', \%symbol);
		$ref_output = \%symbol;
	}
	return($ref_output);
}



# ѥʬ (ʸ n ʸʾȤ߹碌ǽи٤ι⤤) 򸫤ĤƥåȤ
sub CUT_PART_PATTERN {
	my($ref_line, $pattern_frequency_border, $ref_symbol) = @_;
	my($ascii, $length_line, $pointer, @pointer_step, @pointer_symbol);
	my($ngram, %ngram_frequency, @pattern, $pattern);
	my($line_old, $flag_change, $counter);

	$length_line = length($$ref_line);
	# $line γʸ @pointer_step ˡʸݤ @pointer_symbol 
	$pointer = 0;
	$counter = 0;
	while ($pointer < $length_line) {
		$ascii = substr($$ref_line, $pointer, 1);
		if (unpack('C', $ascii) >= 0xA1) {
			$pointer_step[$pointer] = 2;
			$ascii .= substr($$ref_line, $pointer + 1, 1);
		} else {
			$pointer_step[$pointer] = 1;
		}
		if ($$ref_symbol{$ascii} == 1) {
			$pointer_symbol[$pointer] = 1;
			$counter ++;
		}
		$pointer += $pointer_step[$pointer];
	}
	if ($counter >= $pattern_frequency_border + 1) {
		# ʸ¿Τ N-gram פȤ
		$pointer = 0;
		while ($pointer < $length_line) {
#			if (($pointer_symbol[$pointer] == 1) && ($pointer_symbol[$pointer + $pointer_step[$pointer]] == 1)) {
#				# ʸ 2 ʸȤ߹碌
#				$ngram = substr($$ref_line, $pointer, $pointer_step[$pointer] + $pointer_step[$pointer + $pointer_step[$pointer]]);
			if (
					($pointer_symbol[$pointer] == 1) && 
					($pointer_symbol[$pointer + $pointer_step[$pointer]] == 1) &&
					($pointer_symbol[$pointer + $pointer_step[$pointer] + $pointer_step[$pointer + $pointer_step[$pointer]]] == 1)
				) {
				# ʸ 3 ʸȤ߹碌
				$ngram = substr($$ref_line, $pointer, 
						$pointer_step[$pointer] + 
						$pointer_step[$pointer + $pointer_step[$pointer]] + 
						$pointer_step[$pointer + $pointer_step[$pointer] + $pointer_step[$pointer + $pointer_step[$pointer]]]
					);
				while (($pointer + length($ngram)) <= $length_line) {
					$ngram_frequency{$ngram} ++;
					if ($ngram_frequency{$ngram} > $pattern_frequency_border) {	# for ®
						last;
					} elsif ($pointer_symbol[$pointer + length($ngram)] == 1) {
						$ngram .= substr($$ref_line, $pointer + length($ngram), $pointer_step[$pointer + length($ngram)]);
						if (length($ngram) * 2 > $length_line) {	# for ®
							last;
						}
					} else {
						last;
					}
				}
			}
			$pointer += $pointer_step[$pointer];
		}
		# $ngram и٤⤤˥ȡĹ˥Ȥơå
		@pattern = sort { ($ngram_frequency{$b} <=> $ngram_frequency{$a}) or (length($b) <=> length($a)) } keys %ngram_frequency;
		while (@pattern) {
			$pattern = shift(@pattern);
			if ($ngram_frequency{$pattern} < $pattern_frequency_border) {
				last;
			} else {
				&VERBOSE('detail', 'detail', 'CUT(part_pattern): pattern = ' . $pattern .' (x' . $ngram_frequency{$pattern} . ')');
				$pattern = quotemeta($pattern);
				$line_old = $$ref_line;
				$$ref_line =~ s/$pattern//g;
				if ($$ref_line ne $line_old) {
					$flag_change = 'yes';
				}
				last;
			}
		}
		# ԤѲΤǺƵƤӽФ
		if (($flag_change eq 'yes') && (length($$ref_line) >= $pattern_frequency_border + 1)) {
			$ref_line = &CUT_PART_PATTERN($ref_line, $pattern_frequency_border, $ref_symbol);
		}
	}
	return($ref_line);
}



# ѹԤ򸫤ĤƵιԿˤޤȤ ( &CONVERT_ZENHAN ܤƤۤμ)
sub COMPRESS_QUOTATION {
	my($ref_text, $quotation_regex, $line_quotation_max, $flag_display_counter, $remain_regex) = @_;
	my($line, @text_new, @part, $counter, $flag_quotation);
	my($part_from, $part_space, $part_quotation, $part_body);

	$flag_quotation = 'no';
	while (@$ref_text) {
		$line = shift(@$ref_text);
		if (($remain_regex ne '') && ($line =~ /$remain_regex/o)) {
			# Ф˻Ĥ
			push(@text_new, $line);
		} else {
			# Ǥʤ
			if ($line =~ /$quotation_regex/o) {
				# ѹ
				$part_from = $1;
				$part_quotation = $2;
				$part_space = $3;
				$part_body = $4;
				if ($part_body ne '') {
					if ($flag_quotation ne 'yes') {
						# ޤޤ̾Ԥä
						if ($$ref_text[0] ne '') {
							# ̾ԤμԤǤʤä硤Ԥä
							push(@text_new, '');
						}
						$flag_quotation = 'yes';
					}
					$counter ++;
					if ($counter <= $line_quotation_max) {
						push(@part, $part_from . $part_quotation . $part_space . $part_body);
					}
				}
			} else {
				# ̾
				if ($flag_quotation eq 'yes') {
					# ޤޤǰѹԤä
					if ($flag_display_counter eq 'yes') {
						$part[$#part] .= ' ' . $counter;
					}
					push(@text_new, @part);
					if ($line ne '') {
						# ѹԤμԤǤʤä硤Ԥä
						push(@text_new, '');
					}
					@part = ();
					$flag_quotation = 'no';
					$counter = 0;
				}
				push(@text_new, $line);
			}
		}
	}
	if ($part[0] ne '') {
		push(@text_new, @part);
	}
	return(\@text_new);
}



# ԤǤʸ᤹ (ܸѡ &CONVERT_SPACE ܤƤ뤳Ȥ)
sub CONVERT_SENTENCE {
	my($ref_text, $quotation_regex) = @_;
	my(%character_comma) = ('' => 1, '' => 1);	# &CONVERT_ZENHAN1, &CONVERT_ZENHAN2 ȴط
	my(%character_period) = ('' => 1, '' => 1);
	my(@text, $line, $line_buffer, $pointer, $ascii, $pointer_step);
	my($counter, @flag_sentence, @flag_lastperiod, $text);
	my($cr) = "\x0A";	# ٤Ƥ OS ǲԤХȤɽ뤿

	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		$line = $$ref_text[$counter];
		$flag_sentence[$counter] = 'no';
		$flag_lastperiod[$counter] = 'no';
		if (!( ($line eq '') || ($line =~ /$quotation_regex/o) )) {
			# ԤǤѹԤǤʤ
			$pointer = 0;
			$line_buffer = '';
			while ($pointer < length($line)) {
				$ascii = substr($line, $pointer, 1);
				if (unpack('C', $ascii) >= 0xA1) {
					# Хʸ
					$ascii .= substr($line, $pointer + 1, 1);
					$pointer_step = 2;
					if ($character_comma{$ascii} == 1) {
						# ȯ
						$flag_sentence[$counter] = 'yes';
						$line_buffer .= $ascii;
					} elsif ($character_period{$ascii} == 1) {
						# ԥꥪȯ
						$line_buffer .= $ascii;
						$flag_sentence[$counter] = 'yes';
						if ($pointer == length($line) - 2) {
							# Υԥꥪ
							$flag_lastperiod[$counter] = 'yes';
						} else {
							$line_buffer .= $cr;
						}
					} else {
						$line_buffer .= $ascii;
					}
				} else {
					# Хʸ
					$pointer_step = 1;
					$line_buffer .= $ascii;
				}
				$pointer += $pointer_step;
			}
			$$ref_text[$counter] = $line_buffer;
		}
	}
	$counter = 0;
	while (@$ref_text) {
		$line = shift(@$ref_text);
		if ((($flag_sentence[$counter] eq 'yes') && ($flag_sentence[$counter + 1] eq 'yes')) && ($flag_lastperiod[$counter] ne 'yes')) {
			$text .= $line;
		} else {
			$text .= $line . $cr;
		}
		$counter ++;
	}
	@text = split($cr, $text);
	return(\@text);
}



# äƥȥǡΥХȿꤹ
sub COUNT_LENGTH {
	my($ref_text) = @_;
	my($counter, $length);

	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		$length += length($$ref_text[$counter]) + 2;	# \n in SMTP (\x0D\x0A)
	}
	return($length);
}



# ǡ١ĴƹԤνиΨߤʤΤե饰
sub CHECK_DATABASE {
	my($mode, $dir, $charset, $ref_header, $ref_text, $rate_activate, $rate_deactivate, $rate_forget, $quotation_regex, $flag_fuzzy, $length_activate) = @_;
	my($dir_sub, $file, $file_tmp, %text, $line, $counter, $rate, $flag_write);
	my($counter_change, $counter_match, $counter_process, $status, $body, $address);
	my(@flag_alive, $ref_flag_alive);
	my($file_rename);

	# ǥ쥯ȥꡦե̾η
	if ($mode eq 'personal') {
		# ̥⡼
		$file = $$ref_header{'FROM'};
		if ($file ne '') {
			$file =~ s/\W//g;
			$file =~ tr/A-Z/a-z/;
			$dir_sub = sprintf('%02lx', unpack('%16C*', $file) % 32) . '/';
			$file = substr($file, 0, 12);
		} else {
			$file = '_nobody';
		}
	} else {
		# ͭ⡼
		$file = '_common';
	}
	&CHECK_DIR($dir, oct('700'));
	$charset =~ s/\W//g;
	$charset = substr($charset, 0, 12);
	$dir = $dir . $charset . '/';
	&CHECK_DIR($dir, oct('700'));
	if ($dir_sub ne '') {
		$dir .= $dir_sub;
		&CHECK_DIR($dir, oct('700'));
	}
	$file = $dir . $file . '.dat';
	$file_tmp = $file . '.writing';

	# ᡼ʸϥåѴ
	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		# ֹȶ˳ФƤ
		$body = $$ref_text[$counter];
		if ($flag_fuzzy eq 'yes') {
			$body = ${&CHECK_DATABASE_FUZZY($mode, $charset, \$body)};
		}
		$text{$body} .= $counter . ',';
	}
	chop(%text);

	# 񤭹ѥǡ١եѰդ
	$file_rename = &LOCK_FILE($file);
	open(FILE2, ">$file_tmp");
	chmod(oct('600'), $file_tmp);
	$flag_write = 'no';
	# ǡ١եɤ߹
	open(FILE1, "$file_rename");
	if ($mode eq 'personal') {
		# ̥⡼
		while (defined($line = <FILE1>)) {
			chop($line);
			($counter_match, $counter_process, $status, $body) = split("\t", $line, 4);
			if ($body ne '') {
				$counter_process ++;
				$rate = $counter_match / $counter_process;
				if (exists($text{$body})) {
					# ǡ١ΤιԤ᡼¸ߤ
					$counter_match ++;
					if (($status == 0) && ($rate_activate <= $rate)) {
						# deactive ǡиΨ $rate_activate ʾˤʤä
						$status = 1;
					} elsif (($status == 1) && ($rate_deactivate >= $rate)) {
						# active ǡиΨ $rate_deactivate ʲˤʤä
						$status = 0;
					}
					if ($status == 0) {
						# deactive ʤʤ
						$ref_flag_alive = &CHECK_DATABASE_REBUILD(\@flag_alive, $text{$body});
					}
					delete($text{$body});
				} else {
					# ǡ١ΤιԤ᡼¸ߤʤä
					if ($rate_forget >= $rate) {
						# иΨ $rate_forget ʲˤʤä񤭽Фʤ
						next;
					}
				}
				print FILE2 join("\t", $counter_match, $counter_process, $status, $body) . "\n";
				$flag_write = 'yes';
			}
		}
	} else {
		# ͭ⡼
		while (defined($line = <FILE1>)) {
			chop($line);
			($counter_change, $counter_match, $counter_process, $status, $body, $address) = split("\t", $line, 6);
			if ($body ne '') {
				$counter_process ++;
				if (exists($text{$body})) {
					# ǡ١ΤιԤ᡼¸ߤ
					$counter_match ++;
					if ($address ne $$ref_header{'FROM'}) {
						$counter_change ++;
						$address = $$ref_header{'FROM'};
					}
					$rate = $counter_change / $counter_match;
					if (($status == 0) && ($rate_activate <= $rate)) {
						# deactive ǡɥ쥹Ψ $rate_activate ʾˤʤä
						$status = 1;
					} elsif (($status == 1) && ($rate_deactivate >= $rate)) {
						# active ǡɥ쥹Ψ $rate_deactivate ʲˤʤä
						$status = 0;
					}
					if (($status == 0) || (($status == 1) && (length($body) < $length_activate))) {
						# deactive activate ǤĹûкʤ
						$ref_flag_alive = &CHECK_DATABASE_REBUILD(\@flag_alive, $text{$body});
					}
					delete($text{$body});
				} else {
					# ǡ١ΤιԤ᡼¸ߤʤä
					if (($counter_match < 1) || ($rate_forget >= ($counter_match / $counter_process) * (1 + $counter_change / $counter_match))) {
						# 餫ͳ $counter_match ͤиΨ * (1 + ɥ쥹Ψ)  $rate_forget ʲˤʤä񤭽Фʤ
						next;
					}
				}
				print FILE2 join("\t", $counter_change, $counter_match, $counter_process, $status, $body, $address) . "\n";
				$flag_write = 'yes';
			}
		}
	}
	close(FILE1);
	# Ԥǡ١ɲäФ
	while (($body, undef) = each(%text)) {
		$ref_flag_alive = &CHECK_DATABASE_REBUILD(\@flag_alive, $text{$body});
#		if (($body ne '') && (!($body =~ /$quotation_regex/o))) {
#			# ԤǤѹԤǤʤ
		if ($body ne '') {
			# ԤǤϤʤ
			if ($flag_fuzzy eq 'yes') {
				$body = ${&CHECK_DATABASE_FUZZY($mode, $charset, \$body)};
			}
			if ($mode eq 'personal') {
				print FILE2 join("\t", 1, 1, 0, $body) . "\n";
			} else {
				print FILE2 join("\t", 0, 1, 1, 0, $body, $$ref_header{'FROM'}) . "\n";
			}
			$flag_write = 'yes';
		}
	}
	close(FILE2);
	# եؤ
	if ($flag_write eq 'yes') {
		rename($file_tmp, $file);	# ξ̤ˡǥåե
		unlink($file_rename);
	} else {
		unlink($file_tmp);
		&UNLOCK_FILE($file_rename);
	}
	return($ref_flag_alive);
}
sub CHECK_DATABASE_REBUILD {
	my($ref_flag, $number) = @_;
	my(@number);

	@number = split(',', $number);
	while (@number) {
		$number = shift(@number);
		$$ref_flag[$number] = 1;
	}
	return($ref_flag);
}
sub CHECK_DATABASE_FUZZY {
	my($mode, $charset, $ref_line) = @_;

	if ($mode eq 'common') {
#		# Ϣ³ 0 ֤
#		$line =~ s/[0-9]/0/g;
		# ե٥åȤʸˤ
		$$ref_line =~ tr/A-Z/a-z/;
	}
	#  (ȴִ)
	$$ref_line =~ s/!|\?//g;
	if ($charset eq 'japanese') {
#		jcode::tr($ref_line, '', '');
		$$ref_line =~ s/|||||//g;
	}
	return($ref_line);
}



# quoted-printable, base64 ǥɤ
sub DECODE_MIME_TEXT {
	my($ref_text, $mode) = @_;
	my($text, @text);

	$text = &bodydecode(join("\n", @$ref_text), $mode);	# mimer.pl
	&bdeflush;
	@text = split("\n", $text);
	return(\@text);
}



# ǥɤ (: [skypl:2420,2428] ĽꤵΥ)
sub DECODE_MIME_LINE {
	my($line) = @_;
	my($pattern_base64_sjis) = '=\?shift_jis\?B\?([a-z0-9\+\/]+)=*\?=';
	my($pattern_base64_euc) = '=\?euc_jp\?B\?([a-z0-9\+\/]+)=*\?=';
	my($pattern_qp_jis) = '=\?iso-2022-jp\?Q\?(.+)=*\?=';

	if ($line =~ /$pattern_base64_sjis/io) {
		# Shift_JIS (B)
		$line =~ s/$pattern_base64_sjis/&MIME::base64decode($1)/gieo;	# mimer.pl
		jcode::sjis2euc(\$line, 'z');
	} elsif ($line =~ /$pattern_base64_euc/io) {
		# EUC-JP (B)
		$line =~ s/$pattern_base64_euc/&MIME::base64decode($1)/gieo;	# mimer.pl
	} elsif ($line =~ /$pattern_qp_jis/io) {
		# JIS (Q)
		$line =~ s/$pattern_qp_jis/&MIME::qpdecode($1)/gieo;	# mimer.pl
		jcode::jis2euc(\$line, 'z');
	} else {
		# ֤ JIS (B)
		$line = &mimedecode($line, 'EUC');	# mimer.pl
	}
	return($line);
}



# ܸ EUC Ѵԥɤ줹
sub CONVERT_EUC {
	my($ref_text) = @_;
	my($code);

	$code = jcode::getcode($ref_text);
	if (($code eq 'jis') || ($code eq 'sjis') || ($code eq 'euc')) {
		jcode::convert($ref_text, 'euc', $code, 'z');
	}
	$$ref_text =~ s/\x0D\x0A/\n/g;
	$$ref_text =~ tr/\x0D\x0A/\n\n/;
	return($ref_text, $code);
}



# ᡼뤫ƥʬȴФ
sub EXTRACT_PLAINTEXT {
	my($ref_header, $ref_text, $address_regex, $filename) = @_;
	my($ref_part, $boundary, $part, @part, @text_new);
	my($type, $encoding);
	my($flag_duplicate, $counter, $text, @part_text);

	# źեե̾Ф
#	if ($$ref_header{'CONTENT-TYPE'} =~ /application\/octet-stream;\s*name\s*=\s*"?([^";]+)"?/i) {
	if ($$ref_header{'CONTENT-TYPE'} =~ /name\s*=\s*"?([^";]+)"?/i) {
		$filename .= &DECODE_MIME_LINE($1) . ',';
	} elsif ($$ref_header{'CONTENT-DISPOSITION'} =~ /filename\s*=\s*"?([^";]+)"?/i) {
		$filename .= &DECODE_MIME_LINE($1) . ',';
	} else {
		# Content-Type å
		if (($$ref_header{'CONTENT-TYPE'} eq '') || ($$ref_header{'CONTENT-TYPE'} =~ /^text\/(plain|html)/i) || ($$ref_header{'CONTENT-TYPE'} =~ /^message\/(partial)/i)) {
			$type = $1;
			if ($type eq 'partial') {
				$$ref_header{'CONTENT-TYPE'} =~ /;\s*number\s*=\s*(\d+);/i;
				if ($1 != 1) {
					# Content-Type: message/partial ϰܰʳϽʤ
					&VERBOSE('normal', 'normal', 'EXIT(partial): this mail is not supported (skipped). / subject=' . $$ref_header{'SUBJECT'} . '; from=' . $$ref_header{'FROM'} . '; to=' . $$ref_header{'TO'} . '; content-type=' . $$ref_header{'CONTENT-TYPE'});
					&SECTION_EXIT();
					exit;
				}
			}
			$encoding = $$ref_header{'CONTENT-TRANSFER-ENCODING'};
			$type =~ tr/A-Z/a-z/;
			$encoding =~ tr/A-Z/a-z/;
			if ($encoding eq 'quoted-printable') {
				$ref_text = &DECODE_MIME_TEXT($ref_text, 'qp');
			} elsif ($encoding eq 'base64') {
				$ref_text = &DECODE_MIME_TEXT($ref_text, 'b64');
			}
			$text = join("\n", @$ref_text);
			@part = split("\n", ${(&CONVERT_EUC(\$text))[0]});
			$ref_text = \@part;
			if ($type eq 'html') {
				# text/html ʤ HTML Ǥ⥫åȤƤߤ뤫
				$ref_text = &PROCESS_HTMLTAG($ref_text);
			}
			push(@text_new, @$ref_text);
		} elsif ($$ref_header{'CONTENT-TYPE'} =~ /boundary\s*=\s*"?([^";\s]+)"?/i) {
			# boundary ꤬
			$boundary = $1;
			&VERBOSE('detail', 'detail', 'FIND(multipart): boundary = ' . $boundary);
			$ref_part = &EXTRACT_MULTIPART($ref_text, $boundary);
			while (@$ref_part) {
				$part = shift(@$ref_part);
				if ($part ne '') {
					@part = split("\n", $part);
					($ref_text, $filename) = &EXTRACT_PLAINTEXT((&EXTRACT_HEADER(\@part, $address_regex)), $address_regex, $filename);
					# Ƥνʣå
					$flag_duplicate = 'no';
					$text = join('', @$ref_text);
					$text =~ s/\s//g;
					for ($counter = 0; $counter < scalar(@part_text); $counter ++) {
						if (($text ne '') && ($part_text[$counter] ne '')) {
							if ((index($text, $part_text[$counter]) > -1) || (index($part_text[$counter], $text) > -1)) {
								# ΥѡȤƤ¾ΥѡȤˤޤޤƤ
								$flag_duplicate = 'yes';
								last;
							}
						}
					}
					if ($flag_duplicate ne 'yes') {
						push(@text_new, @$ref_text);
						push(@part_text, $text);
					}
				}
			}
		}
	}
	return(\@text_new, $filename);
}



# HTML 򥫥åȤ (˻: <http://www.din.or.jp/~ohzaki/perl.htm#Tag_Remove>)
sub PROCESS_HTMLTAG {
	my($ref_text) = @_;
	my($tag_regex_, $comment_tag_regex, $tag_regex, $text_regex, $result, $str, $tag_tmp);
	my(@text);

	$str = join("\n", @$ref_text);
	$tag_regex_ = q{[^"'<>]*(?:"[^"]*"[^"'<>]*|'[^']*'[^"'<>]*)*(?:>|(?=<)|$(?!\n))};
	$comment_tag_regex = '<!(?:--[^-]*-(?:[^-]+-)*?-(?:[^>-]*(?:-[^>-]+)*?)??)*(?:>|$(?!\n)|--.*$)';
	$tag_regex = qq{$comment_tag_regex|<$tag_regex_};
	$text_regex = q{[^<]*};
	while ($str =~ /($text_regex)($tag_regex)?/gso) {
		last if $1 eq '' and $2 eq '';
		$result .= $1;
		$tag_tmp = $2;
		if ($tag_tmp =~ /^<(XMP|PLAINTEXT|SCRIPT)(?![0-9A-Za-z])/i) {
			$str =~ /(.*?)(?:<\/$1(?![0-9A-Za-z])$tag_regex_|$)/gsi;
			$result .= $1;
		}
	}
	# HTML Ѵ
	$result =~ s/&gt;/>/g;
	$result =~ s/&lt;/</g;
	$result =~ s/&nbsp;/ /g;
	$result =~ s/&quot;/"/g;
	$result =~ s/&amp;/&/g;
	@text = split("\n", $result);
	return(\@text);
}



# multipart ʬ䤹
sub EXTRACT_MULTIPART {
	my($ref_text, $boundary) = @_;
	my(@part, $boundary_last);

	$boundary = '--' . quotemeta($boundary);
	$boundary_last = $boundary . '--';
	@part = split($boundary . "\n", join("\n", @$ref_text));
	$part[$#part] =~ s/$boundary_last$//;
	return(\@part);
}



# ᡼إå CONTENT-TYPE:  charset ȴФ
sub EXTRACT_CHARSET {
	my($contenttype) = @_;
	my($charset);

	if ($contenttype =~ /charset\s*=\s*"?([^";\s]+)"?/i) {
		$charset = $1;
		$charset =~ tr/A-Z/a-z/;
	}
	return($charset);
}



# ɽˤԤΥå
sub CUT_LINE_REGEX {
	my($ref_text, $cut_regex) = @_;
	my($counter);

	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		if ($$ref_text[$counter] =~ /$cut_regex/o) {
			&VERBOSE('detail', 'detail', 'CUT(line_regex): line = ' . $$ref_text[$counter] .' (=~ /' . $cut_regex . '/)');
			$$ref_text[$counter] = '';
		}
	}
	return($ref_text);
}



# ɽˤʬΥå
sub CUT_PART_REGEX {
	my($line, $cut_regex) = @_;

	if ($line =~ /$cut_regex/o) {
		&VERBOSE('detail', 'detail', 'CUT(part_regex): line = ' . $line .' (=~ /' . $cut_regex . '/)');
		$line =~ s/$cut_regex//g;
	}
	return($line);
}



# ե饰ˤԤ
sub CUT_LINE_DATABASE {
	my($ref_text, $ref_flag_alive_common, $ref_flag_alive_personal, $remain_regex) = @_;
	my($counter, $tmp);

	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		if ($$ref_flag_alive_common[$counter] * $$ref_flag_alive_personal[$counter] == 0) {
			if (($remain_regex ne '') && ($$ref_text[$counter] =~ /$remain_regex/o)) {
				# ĤԤˤϤ餺
				next;
			} else {
				$tmp = '';
				if ($$ref_flag_alive_common[$counter] == 0) {
					$tmp .= 'common,';
				}
				if ($$ref_flag_alive_personal[$counter] == 0) {
					$tmp .= 'personal,';
				}
				chop($tmp);
				&VERBOSE('detail', 'detail', 'CUT(line_database): line = ' . $$ref_text[$counter] . ' (by ' . $tmp . ')');
				$$ref_text[$counter] = '';
			}
		}
	}
	return($ref_text);
}



# ԤƤޤȤ
sub COMPRESS_LINE {
	my($ref_text, $level, $convert_space) = @_;
	my($counter_empty, $counter_contents, @text, $line);

	# level 1: İʾĤˡ2: İʾĤˡϢ³ƹԤԤˡ3: Ԥ򥫥åȡϢ³ƹԤԤ
	$counter_empty = 0;
	$counter_contents = 0;
	while (@$ref_text) {
		$line = shift(@$ref_text);
		if ($line eq '') {
			# Ԥȯ
			$counter_empty ++;
			$counter_contents = 0;
			if ($counter_empty >= (2 - int($level * 0.5 - 0.1))) {
				# ԤޤȤ롦åȤ
				next;
			}
		} else {
			# ƹԤȯ
			$counter_empty = 0;
			$counter_contents ++;
		}
		if (($level >= 2) && ($counter_contents > 1)) {
			# ƹԤϢ³
			if (($convert_space eq 'yes') && ((unpack('C', substr($text[$#text], -1, 1)) >= 0xA1) && (unpack('C', substr($line, 0, 1)) >= 0xA1))) {
				$text[$#text] .= $line;
			} else {
				$text[$#text] .= ' ' . $line;
			}
		} else {
			push(@text, $line);
		}
	}
	return(\@text);
}



# URL ʸִ
sub REPLACE_URL {
	my($ref_text, $string, @regex) = @_;
	my($text, $line, @text);

	$text = join("\n", @$ref_text);
	while (@regex) {
		$line = shift(@regex);
		$text =~ s/$line/$string/g;
	}
	@text = split("\n", $text);
	return(\@text);
}



# Ƽ⥸塼ɤ߹ߡСå򤹤
sub CHECK_MODULE {
	my($name) = @_;
	my($command, $version);

	if ($name eq 'Net::SMTP') {
		if ($setting{'check_module_netsmtp'} ne 'done') {
			$version = &CHECK_MODULE_NUMERICAL($setting{'version_module_netsmtp'});
			if (($version - &CHECK_MODULE_NUMERICAL($Net::SMTP::VERSION)) > 0) {
				&VERBOSE('error', 'error', 'ERROR: Net::SMTP module must be newer than version ' . $version . '. / version = ' . $Net::SMTP::VERSION);
			}
			$setting{'check_module_netsmtp'} = 'done';
		}
	} elsif ($name eq 'Net::POP3') {
		if ($setting{'check_module_netpop3'} ne 'done') {
			$version = &CHECK_MODULE_NUMERICAL($setting{'version_module_netpop3'});
			if (($version - &CHECK_MODULE_NUMERICAL($Net::POP3::VERSION)) > 0) {
				&VERBOSE('error', 'error', 'ERROR: Net::POP3 module must be newer than version ' . $version . '. / version = ' . $Net::POP3::VERSION);
			}
			$setting{'check_module_netpop3'} = 'done';
		}
#	} elsif ($name eq 'Mail::IMAPClient') {
#		if ($setting{'check_module_mailimapclient'} ne 'done') {
#			if (($version - &CHECK_MODULE_NUMERICAL($Mail::IMAPClient::VERSION)) > 0) {
#				&VERBOSE('error', 'error', 'ERROR: Mail::IMAPClient module must be newer than version ' . $version . '. / version = ' . $Mail::IMAPClient::VERSION);
#			}
#			$setting{'check_module_mailimapclient'} = 'done';
#		}
	}
	return;
}
sub CHECK_MODULE_NUMERICAL {
	my($string) = @_;
	my($integer, $decimal);

	$string =~ /^(\d+)\.(.*)/;
	($integer, $decimal) = ($1, $2);
	$decimal =~ s/[^0-9]//g;
	return($integer . '.' . $decimal);
}



# ޥŸ ($ref_text  $ref_header ȤȤäŸ)
sub EXTEND_MACRO {
	my($mode, $ref_text, $ref_header, $counter) = @_;
	my(%header) = %{$ref_header}; # ޥǻѤ뤿
	my(%text, $key, $value);

	if ($mode =~ /_(\d+)$/) {
		$mode = substr($mode, 0, -length($1));
	} else {
		$mode .= '_';
	}
	while (($key, $value) = each(%$ref_text)) {
		$text{$key} = eval $value;
		if ($@) {
			&VERBOSE('error', 'error', 'ERROR: macro (' . $key . ' = ' . $value . ') is not correct. / ' . $@);
		} else {
			&VERBOSE('detail', 'detail', 'MACRO(' . $mode . ($counter + 1). '): ' . $key . ' = ' . $text{$key});
		}
	}
	return(\%text);
}



# ᡼ʬ䤹
sub SPLIT_MAIL {
	my($ref_header, $ref_text, $split_max, $byte_max, $charset, $jcode, $jcode_subject, $hankakukana, $cr, $convert_zenhan, $optimize_zenhan, $add_contenttype, $byte_before, $byte_after) = @_;
	my(%envelope_1, %envelope_2, %header_1, %header_2, %body_1, %body_2, %byte_1, %byte_2);
	my(%envelope, %header, %body, %byte);
	my($pointer, $pointer_old, $pointer_step, $pointer_step_old);
	my($ascii, $line, $line_split, $line_split_old, $line_hankaku, $line_hankaku_old);
	my($byte_remain, $byte_split, $byte_split_old, $byte_esc);
	my($key, $tmp, $flag_optimize, $counter, $counter_change);
	my(@mail_from, @mail_to, @mail_data, $tmp1, $tmp2);
	my($split_backup);
	my($byte_line);
	my(%content_charset) = ('sjis' => 'Shift_JIS', 'jis' => 'ISO-2022-JP', 'euc' => 'EUC-JP');
	my(%content_encoding) = ('sjis' => '8bit', 'jis' => '7bit', 'euc' => '8bit');
	my($cr_smtp) = "\x0D\x0A";	# \n in SMTP

	# ᡼γʬ (ޥ̤Ÿ)
	while (($key, undef) = each(%setting)) {
		if ($key =~ /^macro_envelope_([^_]+)_1/) {
			$tmp = $1;
			$tmp =~ tr/a-z/A-Z/;
			$envelope_1{$tmp} = $setting{'macro_envelope_' . $1 . '_1'};
			$envelope_2{$tmp} = $setting{'macro_envelope_' . $1 . '_2'};
		} elsif ($key =~ /^macro_header_([^_]+)_1/) {
			$tmp = $1;
			$tmp =~ tr/a-z/A-Z/;
			$header_1{$tmp} = $setting{'macro_header_' . $1 . '_1'};
			$header_2{$tmp} = $setting{'macro_header_' . $1 . '_2'};
		} elsif ($key =~ /^macro_body_([^_]+)_1/) {
			$tmp = $1;
			$tmp =~ tr/a-z/A-Z/;
			$body_1{$tmp} = $setting{'macro_body_' . $1 . '_1'};
			$body_2{$tmp} = $setting{'macro_body_' . $1 . '_2'};
		} elsif ($key =~ /^macro_byte_([^_]+)/) {
			$tmp = $1;
			$tmp =~ tr/a-z/A-Z/;
			$byte_1{$tmp} = $setting{'macro_byte_' . $1};
			$byte_2{$tmp} = $setting{'macro_byte_' . $1};
		}
	}
	# ʸʤɤβ
	$pointer = 0;
	if ($cr eq '\n') {
		$cr = "\x0A";	# ٤Ƥ OS ǲԤХȤɽ뤿
	}
	$line = join($cr, @$ref_text);
	if ($jcode eq 'jis') {
		$byte_esc = 3;
		if (($charset eq 'japanese') && ($convert_zenhan eq 'yes') && ($optimize_zenhan eq 'yes')) {
			$flag_optimize = 'yes';
		} else {
			$flag_optimize = 'no';
		}
	} else {
		$byte_esc = 0;
		$flag_optimize = 'no';
		if ($hankakukana eq 'yes') {
			jcode::z2h_euc(\$line);
		}
	}
	if ($byte_before > 0) {
		$setting{'mail_ratio_compression'} = sprintf('%d', 100 * $byte_after / $byte_before);
	}

	# ᡼ʬ䳫
	$counter = 0;
	# ̣Υ᡼ʬ뤿
	$split_backup = $setting{'mail_split'};
	$setting{'mail_split'} = "\x00" x length($split_max);
	while (($counter < $split_max) && ($pointer < length($line))) {
		$setting{'mail_split_now'} = $counter + 1;
		# ޥŸ
		if ($counter == 0) {
			%envelope = %{&EXTEND_MACRO('envelope_1', \%envelope_1, $ref_header, $counter)};
			%header = %{&EXTEND_MACRO('header_1', \%header_1, $ref_header, $counter)};
			%body = %{&EXTEND_MACRO('body_1', \%body_1, $ref_header, $counter)};
			%byte = %{&EXTEND_MACRO('byte', \%byte_1, \%header, $counter)};
		} else {
			%envelope = %{&EXTEND_MACRO('envelope_2', \%envelope_2, $ref_header, $counter)};
			%header = %{&EXTEND_MACRO('header_2', \%header_2, $ref_header, $counter)};
			%body = %{&EXTEND_MACRO('body_2', \%body_2, $ref_header, $counter)};
			%byte = %{&EXTEND_MACRO('byte', \%byte_2, \%header, $counter)};
		}
		$header{'DATE'} = (&GET_DATE())[2];
		$header{'MESSAGE-ID'} = &MAKE_MESSAGEID($counter + 1, $$ref_header{'MESSAGE-ID'});
		if ($hankakukana eq 'yes') {
			$tmp = $header{'SUBJECT'};
			jcode::z2h_euc(\$tmp);
			$header{'SUBJECT'} = $tmp;
		}
		# ʬ䶭õʤ᡼ʸ
		$line_split = $body{'HEADER'};
		$line_split_old = '';
		$byte_split = &COUNT_BYTE($line_split, $byte_esc);
		$byte_remain = $byte_max - $byte{'HEADER'} - $byte_split;
		$line_hankaku = '';
		$line_hankaku_old = '';
		$pointer_step_old = 1;
		$pointer_old = length($line);
		$counter_change = 0;
		$byte_line = $byte_split;
		while (1) {
			$ascii = substr($line, $pointer, 1);
			if ((unpack('C', $ascii) >= 0xA1) || (unpack('C', $ascii) == 0x8E)) {
				# Хʸȯ
				$pointer_step = 2;
				if ($pointer_step_old == 1) {
					# ϰХʸ³Ƹ줿
					if (($flag_optimize eq 'yes') && (length($line_hankaku) > 0) && (length($line_hankaku) < 6)) {
						$line_hankaku = &CONVERT_HANZEN($line_hankaku);
					}
					$counter_change ++;
					$byte_line += $byte_esc * 2;
				}
				if (($jcode eq 'sjis') && (unpack('C', $ascii) == 0x8E)) {
					$byte_split += length($line_hankaku) + 1;
					$byte_line += length($line_hankaku) + 1;
				} else {
					$byte_split += length($line_hankaku) + 2;
					$byte_line += length($line_hankaku) + 2;
				}
				$ascii .= substr($line, $pointer + 1, 1);
				$line_split .= $line_hankaku . $ascii;
				$line_hankaku = '';
			} else {
				# Хʸȯ
				$pointer_step = 1;
				if ($ascii eq "\x0A") {
					$line_hankaku .= $cr_smtp;
					$byte_line = 0;
				} else {
					$line_hankaku .= $ascii;
					$byte_line += 1;
				}
			}
			# ѥХȿΥå
			$tmp = $byte_split + $counter_change * $byte_esc * 2 + length($line_hankaku) + length($cr_smtp);
			if (($tmp > $byte_remain) || ($ascii eq '')) {
				$pointer = $pointer_old;
				$line_split = $line_split_old . $line_hankaku_old;
				last;
			} else {
				if ($byte_line >= 990) {
					# 
					$line_split .= $line_hankaku . $cr_smtp;
					$byte_split += length($line_hankaku . $cr_smtp);
					$line_hankaku = '';
					$byte_line = 0;
				}
				$pointer += $pointer_step;
				$pointer_step_old = $pointer_step;
				$pointer_old = $pointer;
				$line_split_old = $line_split;
				$line_hankaku_old = $line_hankaku;
				$byte_split_old = $tmp;
			}
		}
		&VERBOSE('detail', 'detail', 'SPLIT(body_' . ($counter + 1). '): ' . $line_split);
		&VERBOSE('normal', 'detail', 'SPLIT(mail_' . ($counter + 1). '): filling = (' . ($byte_max - $byte_remain) . '+' . ($byte_split_old) . ')/' . ($byte_max) . ' = ' . sprintf('%d', 100 * ($byte_max - $byte_remain + $byte_split_old) / $byte_max) . '%');
		# ᡼ǡѰ
		$mail_from[$counter] = $envelope{'FROM'};
		$mail_to[$counter] = $envelope{'TO'};
		$tmp1 = $header{'SUBJECT'};
		jcode::convert(\$tmp1, $jcode_subject, 'euc');
		$tmp2 = $line_split;
		jcode::convert(\$tmp2, $jcode, 'euc');
		$mail_data[$counter] = '';
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('From', $header{'FROM'});
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('To', $header{'TO'});
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Cc', $header{'CC'});
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Reply-To', $header{'REPLY-TO'});
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Errors-To', $header{'ERRORS-TO'});
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Date', $header{'DATE'});
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Message-ID', '<' . $header{'MESSAGE-ID'} . '>');
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('X-Mailer', $header{'X-MAILER'});
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('X-Remailer', $header{'X-REMAILER'});
		if ($add_contenttype eq 'yes') {
			$mail_data[$counter] .= &SPLIT_MAIL_HEADER('MIME-Version', '1.0');
			$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Content-Type', 'text/plain; charset=' . $content_charset{$setting{'mail_jcode'}});
			$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Content-Transfer-Encoding', $content_encoding{$setting{'mail_jcode'}});
		}
		$mail_data[$counter] .= &SPLIT_MAIL_HEADER('Subject', $tmp1);
		$mail_data[$counter] .= "\n" . $tmp2;
		$counter ++;
	}
	# ̣Υ᡼ʬ
	$split_max = $counter;
	for ($counter = 0; $counter < scalar(@mail_data); $counter ++) {
		$mail_data[$counter] =~ s/$setting{'mail_split'}/$split_max/g;
	}
	$setting{'mail_split'} = $split_backup;
	return($ref_header, $ref_text, \@mail_from, \@mail_to, \@mail_data);
}
sub SPLIT_MAIL_HEADER {
	my($key, $value) = @_;
	my($line);

	if ($value ne '') {
		$line = $key . ': ' . $value . "\n";
	}
	return($line);
}



# ᡼ (by Net::SMTP)
sub SEND_MAIL {
	my($server, $envelope_from, $envelope_to, $data, $timeout, $debug) = @_;
	my($smtp);

	if ($server eq '') {
		&VERBOSE('error', 'error', 'ERROR: not defined - SMTP server');
	}
	$smtp = Net::SMTP->new($server, Timeout => $timeout, Debug => int($debug / 2)) || &VERBOSE('error', 'error', 'ERROR: Net::SMTP new / server = ' . $server);
	$smtp->mail($envelope_from) || &VERBOSE('error', 'error', 'ERROR: Net::SMTP mail = ' . $envelope_from);
	$smtp->recipient($envelope_to) || &VERBOSE('error', 'error', 'ERROR: Net::SMTP recipient = ' . $envelope_to);
	$smtp->data($data) || &VERBOSE('error', 'error', 'ERROR: Net::SMTP data = ' . $data);
	$smtp->quit || &VERBOSE('error', 'error', 'ERROR: Net::SMTP quit');
	return;
}



# ʸνץХȿĴ٤
sub COUNT_BYTE {
	my($line, $byte_esc) = @_;
	my($pointer, $pointer_step, $pointer_step_old, $counter, $counter_change, $ascii);

	if ($byte_esc > 0) {
		$pointer = 0;
		$counter_change = 0;
		$pointer_step_old = 1;
		while ($pointer < length($line)) {
			$ascii = substr($line, $pointer, 1);
			if ((unpack('C', $ascii) >= 0xA1) || (unpack('C', $ascii) == 0x8E)) {
				$pointer_step = 2;
				if (($pointer_step_old == 1) && ($pointer_step == 2)) {
					# ХʸХʸѲ
					$counter_change ++;
				}
			} else {
				$pointer_step = 1;
			}
			$pointer += $pointer_step;
			$pointer_step_old = $pointer_step;
		}
	}
	return(length($line) + $counter_change * 2 * $byte_esc);
}



#  UIDL 򸫤Ĥ
sub CHECK_UIDL {
	my($file, $ref_uidl) = @_;
	my($counter, $key, $value, $line, %flag_new);
	my($file_rename);

	# ֤򥻥å
	while (($key, $value) = each(%$ref_uidl)) {
		$flag_new{$value} = 1;
	}
	# ɤȾȹ
	$file_rename = &LOCK_FILE($file);
	open(FILE, "$file_rename");
	while (defined($line = <FILE>)) {
		chop($line);
		if ($line ne '') {
			$flag_new{$line} = 0;
			$counter ++;
		}
	}
	close(FILE);
	&UNLOCK_FILE($file_rename);
	while (($key, $value) = each(%$ref_uidl)) {
		if ($flag_new{$value} == 0) {;
			delete($$ref_uidl{$key});
		}
	}
	return($ref_uidl, $counter);
}



# ɤ UIDL ¸
sub SAVE_UIDL {
	my($file, $ref_uidl) = @_;
	my($key, $value, $file_rename);

	$file_rename = &LOCK_FILE($file);
	open(FILE, ">>$file_rename");
	chmod(oct('600'), $file_rename);
	while (($key, $value) = each(%$ref_uidl)) {
		print FILE $value . "\n";
	}
	close(FILE);
	&UNLOCK_FILE($file_rename);
	return;
}



# UIDL եݽ
sub CLEANUP_UIDL {
	my($file, $counter_remain) = @_;
	my($file_rename, $file_tmp, $counter, $line);

	$file_rename = &LOCK_FILE($file);
	$file_tmp = $file . '.writing';
	open(FILE_UIDL1, "$file_rename");
	open(FILE_UIDL2, ">$file_tmp");
	chmod(oct('600'), $file_tmp);
	while (defined($line = <FILE_UIDL1>)) {
		$counter ++;
		if (($line ne '') && ($counter > $counter_remain)) {
			print FILE_UIDL2 $line;
		}
	}
	close(FILE_UIDL2);
	close(FILE_UIDL1);
	rename($file_tmp, $file);	# ξ̤ˡǥåե
	unlink($file_rename);
	&VERBOSE('normal', 'normal', 'CLEANUP(uidl): counter = ' . $counter_remain . '; file = ' . $file . ';');
	return;
}



# Message-ID ѤΥˡäݤʸ
sub MAKE_MESSAGEID {
	my($counter, $seed) = @_;
	my($messageid);

	if (($setting{'function_crypt'} ne 'no') && ($seed ne '')) {
		$seed = crypt($seed, ($$ % 100));
		$seed =~ s/\W//g;
		$seed = substr($seed, 2, 8);
	} else {
		$seed = substr(int(rand(10 ** 8)) . $$, 0, 8);
	}
	$messageid = time . '.' . $seed . '.' . $counter . '%' . $setting{'program_address'};
	return($messageid);
}



# ҥץǥץ¹Ԥ
sub EXECUTE_CHILDPROCESS {
	my($argv, $message) = @_;
	my($command);

	if ($^X =~ /(perl|perl\.exe)$/i) {
		# Perl 󥿥ץ꥿ͳʤ
		$command = '"' . $^X . '" ';
	}
	$command .= '"' . $setting{'dir_program'} . $setting{'file_program'} . '" ' . $argv;
	&VERBOSE('detail', 'detail', 'LOAD(' . $message . ') and EXEC: ' . $command);
	$| = 1;
	print `$command` || &VERBOSE('error', 'error', 'ERROR: cannot execute child process. / command = ' . $command);
	if ($?) {
		&VERBOSE('error', 'error', 'ERROR: some problem found in child process. / command = ' . $command);
	}
	$| = 0;
	return;
}



# ڡ򵭹ִ (ޥɥ饤󥪥ץк)
sub ESCAPE_SPACE {
	my($line) = @_;

	$line =~ s/ /\%20/g;
	return($line);
}



# 򥹥ڡִ (ޥɥ饤󥪥ץк)
sub UNESCAPE_SPACE {
	my($line) = @_;

	$line =~ s/\%20/ /g;
	return($line);
}



#---------------------------------------------------

# ޥ: ͤ
sub MACRO_MAX {
	my(@number) = @_;

	@number = sort { $a <=> $b } @number;
	return($number[$#number]);
}

# ޥ: ͤ
sub MACRO_MIN {
	my(@number) = @_;

	@number = sort { $a <=> $b } @number;
	return($number[0]);
}

# ޥ: Хȿ
sub MACRO_BYTE {
	my($line) = @_;

	return(length($line));
}

# ޥ: Хȿκ ($jcode ɽ - euc ɽ)
sub MACRO_BYTE_DIFF {
	my($line, $jcode) = @_;
	my($byte_esc);

	if ($jcode eq 'jis') {
		$byte_esc = 3;
	} else {
		$byte_esc = 0;
	}
	return(&COUNT_BYTE($line, $byte_esc) - length($line));
}

# ޥ: MIME 󥳡ɤ
sub MACRO_MIMEENCODE {
	my($line) = @_;

	return(&mimeencode($line));	# mimew.pl
}

# ޥ: Хȿ (ХȾʤȤ) ʸڤ
sub MACRO_CUT {
	my($line, $byte, $jcode) = @_;

	if ($jcode eq 'jis') {
		$line = substr($line, 0, $byte - &MACRO_BYTE_DIFF($line, 'jis'));
	} else {
		$line = substr($line, 0, $byte);
	}
	if ((($line =~ tr/\x8E\xA1-\xFE//) % 2) == 1) {
		chop($line);
	}
	return($line);
}



1;
